<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/decode_definition_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>05/17/90  decode_definition_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The decode_definition_ subroutine returns decoded information from an
<span id="L5" class="LineNr">  5 </span>object segment definition into a directly accessible structure.
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>Entry points in decode_definition_:
<span id="L9" class="LineNr">  9 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>:Entry: decode_definition_: 05/15/90  decode_definition_
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Function: returns the decoded information of an object segment
<span id="L15" class="LineNr"> 15 </span>definition in a directly accessible structure.  This subroutine can
<span id="L16" class="LineNr"> 16 </span>only be used on one segment at a time because it uses internal static
<span id="L17" class="LineNr"> 17 </span>storage for information about the current segment.
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>Syntax:
<span id="L21" class="LineNr"> 21 </span>declare decode_definition_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_p0">)</span>;
<span id="L22" class="LineNr"> 22 </span>call decode_definition_ <span class="textRainbow_lv0_p0">(</span>def_ptr<span class="textRainbow_lv0_o0">,</span> structure_ptr<span class="textRainbow_lv0_o0">,</span> eof<span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Arguments:
<span id="L26" class="LineNr"> 26 </span>def_ptr
<span id="L27" class="LineNr"> 27 </span>   is a pointer to the selected definition, or to the base of the
<span id="L28" class="LineNr"> 28 </span>   object segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  If def_ptr points to the base of the
<span id="L29" class="LineNr"> 29 </span>   object segment, decode_definition_ returns the first acceptable
<span id="L30" class="LineNr"> 30 </span>   definition in the definition section <span class="textRainbow_lv0_p0">(</span>see Notes<span class="textRainbow_lv0_p0">)</span>.  Otherwise it is
<span id="L31" class="LineNr"> 31 </span>   expected to be pointing to a definition.
<span id="L32" class="LineNr"> 32 </span>structure_ptr
<span id="L33" class="LineNr"> 33 </span>   is a pointer to the structure in which decode_definition_ returns
<span id="L34" class="LineNr"> 34 </span>   the desired information.  This structure is defined in
<span id="L35" class="LineNr"> 35 </span>   decode_definition_str.incl.pl1.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>eof
<span id="L39" class="LineNr"> 39 </span>   is a binary indicator that is &quot;1&quot;b if the current invocation of
<span id="L40" class="LineNr"> 40 </span>   decode_definition_ causes the search to go beyond the end of the
<span id="L41" class="LineNr"> 41 </span>   definition list.  If that is the case, the returned information in
<span id="L42" class="LineNr"> 42 </span>   the structure is null.  It may also be &quot;1&quot;b if any error occurs.
<span id="L43" class="LineNr"> 43 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>Notes: decode_definition_ may not return the definition pointed to by
<span id="L47" class="LineNr"> 47 </span>def_ptr.  It checks the &quot;ignore&quot; bit of each definition, and if that
<span id="L48" class="LineNr"> 48 </span>bit is &quot;1&quot;b it will continue scanning the list of definitions until it
<span id="L49" class="LineNr"> 49 </span>finds one for which the &quot;ignore&quot; bit is not set.
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>To be sure the internal static information about the current segment
<span id="L52" class="LineNr"> 52 </span>has been properly initialized, the first call to decode_definition_
<span id="L53" class="LineNr"> 53 </span>should either pass a pointer to the base of the object segment in
<span id="L54" class="LineNr"> 54 </span>def_ptr, or it should follow a call to decode_definition_$init.
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>When decode_definition_ is called following a call to
<span id="L57" class="LineNr"> 57 </span>decode_definition_$init for the same object segment, it will ignore
<span id="L58" class="LineNr"> 58 </span>the value of def_ptr and always return the first definition in the
<span id="L59" class="LineNr"> 59 </span>definition section <span class="textRainbow_lv0_p0">(</span>for which &quot;ignore&quot; is not set<span class="textRainbow_lv0_p0">)</span>.
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>:Entry:  full:  05/17/90 decode_definition_$full
<span id="L63" class="LineNr"> 63 </span>
<span id="L64" class="LineNr"> 64 </span>Function: This entry point, given a pointer to an object segment
<span id="L65" class="LineNr"> 65 </span>definition, returns more complete information about that definition.
<span id="L66" class="LineNr"> 66 </span>The symbolic name returned by this entry point can contain up to 256
<span id="L67" class="LineNr"> 67 </span>characters.  This entry point does not use internal static storage.
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>
<span id="L70" class="LineNr"> 70 </span>Syntax:
<span id="L71" class="LineNr"> 71 </span>declare decode_definition_$full entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_p0">)</span>;
<span id="L72" class="LineNr"> 72 </span>call decode_definition_$full <span class="textRainbow_lv0_p0">(</span>def_ptr<span class="textRainbow_lv0_o0">,</span> structure_ptr<span class="textRainbow_lv0_o0">,</span> oi_ptr<span class="textRainbow_lv0_o0">,</span> eof<span class="textRainbow_lv0_p0">)</span>;
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>Arguments:
<span id="L76" class="LineNr"> 76 </span>def_ptr
<span id="L77" class="LineNr"> 77 </span>   is a pointer to the selected definition.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.
<span id="L78" class="LineNr"> 78 </span>structure_ptr
<span id="L79" class="LineNr"> 79 </span>   is a pointer to the provided structure into which the
<span id="L80" class="LineNr"> 80 </span>   decode_definition_$full entry point returns the desired information.
<span id="L81" class="LineNr"> 81 </span>   This structure is defined in decode_definition_str.incl.pl1.
<span id="L82" class="LineNr"> 82 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.
<span id="L83" class="LineNr"> 83 </span>oi_ptr
<span id="L84" class="LineNr"> 84 </span>   is a pointer to the structure returned by any entry point of the
<span id="L85" class="LineNr"> 85 </span>   object_info subroutine.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>eof
<span id="L89" class="LineNr"> 89 </span>   is a binary indicator that is &quot;1&quot;b if the current invocation of
<span id="L90" class="LineNr"> 90 </span>   decode_definition_$full causes the search to go beyond the end of
<span id="L91" class="LineNr"> 91 </span>   the definition list.  If that is the case, the returned information
<span id="L92" class="LineNr"> 92 </span>   in the structure is null.  It may also be &quot;1&quot;b if any error occurs.
<span id="L93" class="LineNr"> 93 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>Notes: decode_definition_$full will return the definition pointed to by
<span id="L97" class="LineNr"> 97 </span>def_ptr, whether or not the &quot;ignore&quot; bit is set for that definition.
<span id="L98" class="LineNr"> 98 </span>If def_ptr points to the definition header, however, this entry point
<span id="L99" class="LineNr"> 99 </span>will skip over it and return the first definition in the definition
<span id="L100" class="LineNr">100 </span>section.
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>
<span id="L103" class="LineNr">103 </span>:Entry:  init:  05/16/90 decode_definition_$init
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>Function: This entry point is used for initialization of the internal
<span id="L106" class="LineNr">106 </span>static storage used to locate the current segment.  It is especially
<span id="L107" class="LineNr">107 </span>useful when the object segment does not begin at offset 0 <span class="textRainbow_lv0_p0">(</span>as for an
<span id="L108" class="LineNr">108 </span>archive component<span class="textRainbow_lv0_p0">)</span>.  This entry point only effects the main entry
<span id="L109" class="LineNr">109 </span>point, decode_definition_.
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>Syntax:
<span id="L113" class="LineNr">113 </span>declare decode_definition_$init entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>24<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L114" class="LineNr">114 </span>call decode_definition_$init <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> bit_count<span class="textRainbow_lv0_p0">)</span>;
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>Arguments:
<span id="L118" class="LineNr">118 </span>seg_ptr
<span id="L119" class="LineNr">119 </span>   is a pointer to the beginning of an object segment <span class="textRainbow_lv0_p0">(</span>not necessarily
<span id="L120" class="LineNr">120 </span>   with an offset of 0<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L121" class="LineNr">121 </span>bit_count
<span id="L122" class="LineNr">122 </span>   is the bit count of the object segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
